package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.U64
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.STRING
import ru.landgrafhomyak.db.serdha0.api.table.ForeignRowReference
import ru.landgrafhomyak.db.serdha0.api.table.Table
import ru.landgrafhomyak.db.serdha0.api.table.TableConstructor

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
class T_QueueSets private constructor(creator: TableConstructor.Scope<T_QueueSets>, chatsTable: Table<T_Chats, *>) {
	val C_RowId = creator.rowIdColumn
	val C_Chat = creator.foreignRowReference("chat", chatsTable, ForeignRowReference.OnDelete.CASCADE)
	val C_TgMid = creator.column("telegram::message_id", creator.types.U64)
	val C_Name = creator.column("name", creator.types.STRING)
	val C_IsOpen = creator.column("is_open", creator.types.BOOLEAN)

	val U_TgMid = creator.uniqueIndex("telegram::message_id", true, this.C_Chat, this.C_TgMid)

	val D_IsOpen = creator.defaultValue(this.C_IsOpen, true)

	private class _Constructor(private val chatsTable: Table<T_Chats, *>) : TableConstructor<T_QueueSets> {
		override fun createTable(context: TableConstructor.Scope<T_QueueSets>) =
			T_QueueSets(context, this.chatsTable)

	}

	companion object Constructor {
		operator fun invoke(chatsTable: Table<T_Chats, *>): TableConstructor<T_QueueSets> =
			_Constructor(chatsTable)
	}
}