package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.U8
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.STRING
import ru.landgrafhomyak.db.serdha0.api.table.ForeignRowReference
import ru.landgrafhomyak.db.serdha0.api.table.Table
import ru.landgrafhomyak.db.serdha0.api.table.TableConstructor

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
class T_Queues private constructor(creator: TableConstructor.Scope<T_Queues>, queueSetsTable: Table<T_QueueSets, *>) {
	val C_RowId = creator.rowIdColumn
	val C_QueueSet = creator.foreignRowReference("chat", queueSetsTable, ForeignRowReference.OnDelete.CASCADE)
	val C_Name = creator.column("name", creator.types.STRING)
	val C_Ordinal = creator.column("ordinal", creator.types.U8)

	val U_Id = creator.uniqueIndex("id", true, this.C_QueueSet, this.C_Ordinal)

	private class _Constructor(private val queueSetsTable: Table<T_QueueSets, *>) : TableConstructor<T_Queues> {
		override fun createTable(context: TableConstructor.Scope<T_Queues>) =
			T_Queues(context, this.queueSetsTable)

	}

	companion object Constructor {
		operator fun invoke(queueSetsTable: Table<T_QueueSets, *>): TableConstructor<T_Queues> =
			_Constructor(queueSetsTable)
	}
}