package ru.landgrafhomyak.bgtu.db0.storage.serdha

import kotlin.jvm.JvmStatic
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.STRING
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_QueueSets
import ru.landgrafhomyak.db.serdha0.api.misc.Column
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow
import ru.landgrafhomyak.db.serdha0.api.table.RowId

internal class FoundQueue(
	val rowId: RowId<T_QueueSets>,
	val name: String,
	val isOpen: Boolean
) {
	@Suppress("PropertyName")
	interface QueueSetRow<qUE : Any> {
		val C_QsRowId: Column<RowId<T_QueueSets>, DatabaseType.ROW_ID<T_QueueSets>, qUE>
		val C_QsName: Column<String, STRING, qUE>
		val C_QsIsOpen: Column<Boolean, DatabaseType.BOOLEAN, qUE>
	}

	companion object {
		@JvmStatic
		fun <qUE : QueueSetRow<qUE>> fromRow(ue: qUE, row: OutputRow<qUE>) = FoundQueue(
			rowId = row[ue.C_QsRowId],
			name = row[ue.C_QsName],
			isOpen = row[ue.C_QsIsOpen]
		)
	}
}