package ru.landgrafhomyak.bgtu.db0.storage.serdha

import kotlin.jvm.JvmStatic
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.STRING
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.U8
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_Queues
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_User2Queue
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_Users
import ru.landgrafhomyak.db.serdha0.api.misc.Column
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow
import ru.landgrafhomyak.db.serdha0.api.table.RowId

internal class FoundUserInQueue(
	val linkRowId: RowId<T_User2Queue>,
	val userRowId: RowId<T_Users>,
	val userDisplayName: String,
	val queueRef: RowId<T_Queues>?,
	val ordinal: UByte?
) {
	@Suppress("PropertyName")
	interface UserInQueueRow<qUE : Any> {
		val C_RowId: Column<RowId<T_User2Queue>, DatabaseType.ROW_ID<T_User2Queue>, qUE>
		val C_URowId: Column<RowId<T_Users>, DatabaseType.ROW_ID<T_Users>, qUE>
		val C_UDisplayName: Column<String, STRING, qUE>
		val C_QRowId: Column<RowId<T_Queues>?, DatabaseType.Nullable<RowId<T_Queues>, DatabaseType.ROW_ID<T_Queues>>, qUE>
		val C_Ordinal: Column<UByte?, DatabaseType.Nullable<UByte, U8>, qUE>
	}

	companion object {
		@JvmStatic
		fun <qUE : UserInQueueRow<qUE>> fromRow(ue: qUE, row: OutputRow<qUE>) = FoundUserInQueue(
			linkRowId = row[ue.C_RowId],
			userRowId = row[ue.C_URowId],
			userDisplayName = row[ue.C_UDisplayName],
			queueRef = row[ue.C_QRowId],
			ordinal = row[ue.C_Ordinal]
		)
	}
}