package ru.landgrafhomyak.bgtu.db0.storage.serdha.queries

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.S64
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.STRING
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.U64
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.M_V0
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_Chats
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_QueueSets
import ru.landgrafhomyak.db.serdha0.api.misc._Selectable
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.queries.InsertQuery
import ru.landgrafhomyak.db.serdha0.api.queries._Query
import ru.landgrafhomyak.db.serdha0.api.table.Table

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
internal class I_AddQueueSet(private val module: Module<M_V0>) : _Query.Constructor<InsertQuery.FromSubquery<I_AddQueueSet.I_AddQueueSet>> {
	override fun createQuery(internalQueries: _Query.Constructor.Scope, outQueries: _Query.Constructor.Scope): InsertQuery.FromSubquery<I_AddQueueSet> {
		return outQueries.insertFromSubquery(
			I_AddQueueSet.Constructor(
				this.module.uExt.queueSets,
				internalQueries.insertSingleRow(I_EnsureChat.Constructor(this.module.uExt.chats))
			)
		)
	}

	class I_EnsureChat private constructor(context: InsertQuery.SingleRow.Constructor.Scope<I_EnsureChat, T_Chats>) {
		val P_TgCid = context.queryParam("tg_cid", context.types.S64)

		init {
			context.insertParam(context.tt.uExt.C_TgCid, this.P_TgCid)
			context.onConflictUpdate(context.tt.uExt.U_TgCid) {}
		}

		val C_RowId = context.returnInsertedValue("row_id", context.tt.uExt.C_RowId)

		class Constructor(override val targetTable: Table<T_Chats, *>) : InsertQuery.SingleRow.Constructor<I_EnsureChat, T_Chats> {
			override fun createInsertSingleRowWithReturning(context: InsertQuery.SingleRow.Constructor.Scope<I_EnsureChat, T_Chats>) =
				I_EnsureChat(context)
		}
	}

	class I_AddQueueSet private constructor(context: InsertQuery.FromSubquery.Constructor.Scope<I_AddQueueSet, T_QueueSets, I_EnsureChat>) {
		val P_TgCid = context.queryParam("chat_id", context.types.S64)
		val P_TgMid = context.queryParam("message_id", context.types.U64)
		val P_Name = context.queryParam("name", context.types.STRING)

		init {
			context.sourceQueryParams.redirect(context.src.uExt.P_TgCid, this.P_TgCid)

			context.insertFromSubquery(context.tt.uExt.C_Chat, context.src.uExt.C_RowId)
			context.insertParam(context.tt.uExt.C_TgMid, this.P_TgMid)
			context.insertParam(context.tt.uExt.C_Name, this.P_Name)
		}

		val C_RowId = context.returnInsertedValue("row_id", context.tt.uExt.C_RowId)

		class Constructor(override val targetTable: Table<T_QueueSets, *>, override val selector: _Selectable<I_EnsureChat>) : InsertQuery.FromSubquery.Constructor<I_AddQueueSet, T_QueueSets, I_EnsureChat> {
			override fun createInsertSingleRowWithReturning(context: InsertQuery.FromSubquery.Constructor.Scope<I_AddQueueSet, T_QueueSets, I_EnsureChat>) =
				I_AddQueueSet(context)
		}
	}
}