package ru.landgrafhomyak.bgtu.db0.storage.serdha.queries

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.STRING
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.U8
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.M_V0
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_QueueSets
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_Queues
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.queries.InsertQuery
import ru.landgrafhomyak.db.serdha0.api.table.Table

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
internal class I_AddQueues private constructor(context: InsertQuery.MultipleRows.Constructor.Scope<I_AddQueues, T_Queues>, qsTable: Table<T_QueueSets, *>) {
	val P_QueueSet = context.inputColumn("queue_set", context.types.ROW_ID(qsTable))
	val P_Name = context.inputColumn("name", context.types.STRING)
	val P_Ordinal = context.inputColumn("ordinal", context.types.U8)

	init {
		context.insertColumn(context.tt.uExt.C_QueueSet, this.P_QueueSet)
		context.insertColumn(context.tt.uExt.C_Name, this.P_Name)
		context.insertColumn(context.tt.uExt.C_Ordinal, this.P_Ordinal)
	}

	private class _Constructor(private val module: Module<M_V0>) : InsertQuery.MultipleRows.Constructor<I_AddQueues, T_Queues> {
		override val targetTable: Table<T_Queues, *>
			get() = this.module.uExt.queues

		override fun createInsertMultipleRows(context: InsertQuery.MultipleRows.Constructor.Scope<I_AddQueues, T_Queues>) =
			I_AddQueues(context, this.module.uExt.queueSets)
	}

	companion object Constructor {
		operator fun invoke(module: Module<M_V0>) : InsertQuery.MultipleRows.Constructor<I_AddQueues, T_Queues> = _Constructor(module)
	}
}