package ru.landgrafhomyak.bgtu.db0.storage.serdha.queries

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.M_V0
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_User2Queue
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.queries.InsertQuery
import ru.landgrafhomyak.db.serdha0.api.table.Table

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
internal class I_AddUserToQueue private constructor(context: InsertQuery.SingleRow.Constructor.Scope<I_AddUserToQueue, T_User2Queue>) {
	val P_QueueSet = context.queryParam("queue_set", context.tt.uExt.C_QueueSet.type)
	val P_Queue = context.queryParam("queue", context.tt.uExt.C_Queue.type)
	val P_User = context.queryParam("user", context.tt.uExt.C_User.type)
	val P_Ordinal = context.queryParam("ordinal", context.tt.uExt.C_Ordinal.type)

	init {
		context.insertParam(context.tt.uExt.C_QueueSet, this.P_QueueSet)
		context.insertParam(context.tt.uExt.C_Queue, this.P_Queue)
		context.insertParam(context.tt.uExt.C_User, this.P_User)
		context.insertParam(context.tt.uExt.C_Ordinal, this.P_Ordinal)
	}

	private class _Constructor(
		override val targetTable: Table<T_User2Queue, *>
	) : InsertQuery.SingleRow.Constructor<I_AddUserToQueue, T_User2Queue> {
		override fun createInsertSingleRowWithReturning(context: InsertQuery.SingleRow.Constructor.Scope<I_AddUserToQueue, T_User2Queue>) = I_AddUserToQueue(context)
	}

	companion object Constructor {
		operator fun invoke(module: Module<M_V0>) : InsertQuery.SingleRow.Constructor<I_AddUserToQueue, T_User2Queue> = _Constructor(module.uExt.user2queue)
	}
}