package ru.landgrafhomyak.bgtu.db0.storage.serdha.queries

import ru.landgrafhomyak.bgtu.db0.storage.serdha.FoundUserInQueue
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.M_V0
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_User2Queue
import ru.landgrafhomyak.db.serdha0.api.misc.FiltersScope
import ru.landgrafhomyak.db.serdha0.api.misc._Selectable
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.queries.SelectQuery
import ru.landgrafhomyak.db.serdha0.api.queries._Query

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
internal class S_FindUserInQueue(private val module: Module<M_V0>) : _Query.Constructor<SelectQuery.WithJoin<S_FindUserInQueue.Query>> {
	override fun createQuery(internalQueries: _Query.Constructor.Scope, outQueries: _Query.Constructor.Scope) =
		outQueries.selectWithJoin(
			Query.Constructor(
				internalQueries(U_GetUser(this.module)),
				this.module.uExt.user2queue
			)
		)

	class Query private constructor(context: SelectQuery.WithJoin.Constructor.Scope<Query, U_GetUser, T_User2Queue>) : FoundUserInQueue.UserInQueueRow<Query> {
		val P_TgUid = context.queryParam("tg_uid", context.lsq.uExt.P_TgUid.type)
		val P_UDisplayName = context.queryParam("u_display_name", context.lsq.uExt.P_DisplayName.type)
		val P_QueueSet = context.queryParam("queue_set", context.rsq.uExt.C_QueueSet.type)
		override val C_RowId = context.returnColumn("_row_id", context.selectColumnFromRight(context.rsq.uExt.C_RowId))
		override val C_URowId = context.returnColumn("u_row_id", context.selectColumnFromLeft(context.lsq.uExt.C_RowId))
		override val C_UDisplayName = context.returnColumn("u_display_name", context.selectColumnFromLeft(context.lsq.uExt.C_DisplayName))
		override val C_QRowId = context.returnColumn("queue", context.selectColumnFromRight(context.rsq.uExt.C_Queue))
		override val C_Ordinal = context.returnColumn("queue", context.selectColumnFromRightAsNullable(context.rsq.uExt.C_Ordinal))

		init {
			context.leftSubqueryParams.redirect(context.lsq.uExt.P_TgUid, this.P_TgUid)
			context.leftSubqueryParams.redirect(context.lsq.uExt.P_DisplayName, this.P_UDisplayName)
			context.filters.compareWithParam(context.selectColumnFromRight(context.rsq.uExt.C_QueueSet), FiltersScope.ComparisonType.EQUALS, this.P_QueueSet)
		}

		class Constructor(
			override val left: _Selectable<U_GetUser>,
			override val right: _Selectable<T_User2Queue>
		) : SelectQuery.WithJoin.Constructor<Query, U_GetUser, T_User2Queue> {
			override val joinType = SelectQuery.JoinType(
				leftNull = SelectQuery.JoinType.LeftNull.NULL_NOT_EXPECTED,
				join = SelectQuery.JoinType.Join.LEFT_FOR_EACH_RIGHT_OR_TO_NULL
			)

			override val referenceColumn = this.left.uExt.C_RowId
			override val targetColumn = this.right.uExt.C_QueueSet

			override fun createSelectWithJoin(context: SelectQuery.WithJoin.Constructor.Scope<Query, U_GetUser, T_User2Queue>) =
				Query(context)
		}
	}
}