package ru.landgrafhomyak.bgtu.db0.storage.serdha.queries

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.M_V0
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_Queues
import ru.landgrafhomyak.db.serdha0.api.misc.FiltersScope
import ru.landgrafhomyak.db.serdha0.api.misc._Selectable
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.queries.SelectQuery

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
internal class S_FirstQueueInSet private constructor(context: SelectQuery.Simple.Constructor.Scope<S_FirstQueueInSet, T_Queues>) {
	val P_QueueSet = context.queryParam("queue_set", context.src.uExt.C_QueueSet.type)
	val C_Queue = context.returnColumn("queue", context.selectColumnFromSubquery(context.src.uExt.C_RowId))

	init {
		context.filters.compareWithParam(context.selectColumnFromSubquery(context.src.uExt.C_QueueSet), FiltersScope.ComparisonType.EQUALS, this.P_QueueSet)
		context.orderBy(SelectQuery.Order.ASC, context.selectColumnFromSubquery(context.src.uExt.C_Ordinal))
		context.limit = 1u

	}

	private class _Constructor(
		override val source: _Selectable<T_Queues>
	) : SelectQuery.Simple.Constructor<S_FirstQueueInSet, T_Queues> {
		override fun createSelect(context: SelectQuery.Simple.Constructor.Scope<S_FirstQueueInSet, T_Queues>) = S_FirstQueueInSet(context)
	}

	companion object Constructor {
		operator fun invoke(module: Module<M_V0>) :  SelectQuery.Simple.Constructor<S_FirstQueueInSet, T_Queues> = _Constructor(module.uExt.queues)
	}
}