package ru.landgrafhomyak.bgtu.db0.storage.serdha.queries

import ru.landgrafhomyak.bgtu.db0.storage.serdha.FoundQueue
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.M_V0
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_QueueSets
import ru.landgrafhomyak.db.serdha0.api.misc._Selectable
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.queries.UpdateQuery
import ru.landgrafhomyak.db.serdha0.api.queries._Query
import ru.landgrafhomyak.db.serdha0.api.table.Table

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
internal class U_ChangeQueueState(private val module: Module<M_V0>) : _Query.Constructor<UpdateQuery.FromSubquery<U_ChangeQueueState.Query>> {
	override fun createQuery(internalQueries: _Query.Constructor.Scope, outQueries: _Query.Constructor.Scope) =
		outQueries.updateFromSubquery(
			Query.Constructor(
				this.module.uExt.queueSets,
				internalQueries(S_FindQueueSet(this.module)).byMessage
			)
		)

	class Query private constructor(context: UpdateQuery.FromSubquery.Constructor.Scope<Query, T_QueueSets, S_FindQueueSet.S_FindQueueSetByMessage>) : FoundQueue.QueueSetRow<Query> {
		val P_TgCid = context.queryParam("tg_cid", context.src.uExt.P_TgCid.type)
		val P_TgMid = context.queryParam("tg_mid", context.src.uExt.P_TgMid.type)
		val P_NewState = context.queryParam("new_state", context.types.BOOLEAN)
		val C_OldIsOpen = context.returnOldValue("old_state", context.tt.uExt.C_IsOpen)
		override val C_QsRowId = context.returnNewValue("row_id", context.tt.uExt.C_RowId)
		override val C_QsName = context.returnNewValue("name", context.tt.uExt.C_Name)
		override val C_QsIsOpen = context.returnNewValue("new_state", context.tt.uExt.C_IsOpen)

		init {
			context.selectorParams.redirect(context.src.uExt.P_TgCid, this.P_TgCid)
			context.selectorParams.redirect(context.src.uExt.P_TgMid, this.P_TgMid)

			context.selectorColumn = context.src.uExt.C_QsRowId

			context.ifNoRowSkip()
		}

		class Constructor(
			override val targetTable: Table<T_QueueSets, *>,
			override val selector: _Selectable<S_FindQueueSet.S_FindQueueSetByMessage>
		) : UpdateQuery.FromSubquery.Constructor<Query, T_QueueSets, S_FindQueueSet.S_FindQueueSetByMessage> {

			override fun createUpdateFromSubqueryWithReturning(context: UpdateQuery.FromSubquery.Constructor.Scope<Query, T_QueueSets, S_FindQueueSet.S_FindQueueSetByMessage>) =
				Query(context)
		}
	}
}