package ru.landgrafhomyak.bgtu.db0.storage.serdha.queries

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.STRING
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.U64
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.U8
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.M_V0
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_QueueSets
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_Queues
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_Users
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.queries.InsertQuery
import ru.landgrafhomyak.db.serdha0.api.table.Table

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
class U_GetUser private constructor(context: InsertQuery.SingleRow.Constructor.Scope<U_GetUser, T_Users>) {
	val P_TgUid = context.queryParam("tg_uid", context.types.U64)
	val P_DisplayName = context.queryParam("display_name", context.types.STRING)
	val C_RowId = context.returnInsertedValue("row_id", context.tt.uExt.C_RowId)
	val C_DisplayName = context.returnInsertedValue("display_name", context.tt.uExt.C_DisplayName)

	init {
		context.insertParam(context.tt.uExt.C_TgUid, this.P_TgUid)
		context.insertParam(context.tt.uExt.C_DisplayName, this.P_DisplayName)
		context.onConflictUpdate(context.tt.uExt.U_TgUid) { upd ->
			upd.overrideColumn(context.tt.uExt.C_DisplayName)
		}
	}

	private class _Constructor(private val module: Module<M_V0>) : InsertQuery.SingleRow.Constructor<U_GetUser, T_Users> {
		override val targetTable: Table<T_Users, *> = this.module.uExt.users

		override fun createInsertSingleRowWithReturning(context: InsertQuery.SingleRow.Constructor.Scope<U_GetUser, T_Users>) =
			U_GetUser(context)
	}

	companion object Constructor {
		operator fun invoke(module: Module<M_V0>): InsertQuery.SingleRow.Constructor<U_GetUser, T_Users> = _Constructor(module)
	}
}