package ru.landgrafhomyak.bgtu.db0.storage.serdha.queries

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.M_V0
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0.T_User2Queue
import ru.landgrafhomyak.db.serdha0.api.module.Module
import ru.landgrafhomyak.db.serdha0.api.queries.InsertQuery
import ru.landgrafhomyak.db.serdha0.api.queries.UpdateQuery
import ru.landgrafhomyak.db.serdha0.api.table.Table

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
internal class U_MoveUserInQueue private constructor(context: UpdateQuery.SingleRow.Constructor.Scope<U_MoveUserInQueue, T_User2Queue>) {
	val P_RowId = context.rowToUpdate
	val P_NewQueue = context.queryParam("queue", context.tt.uExt.C_Queue.type)
	val P_NewOrdinal = context.queryParam("ordinal", context.tt.uExt.C_Ordinal.type)

	init {
		context.updateColumnWithParam(context.tt.uExt.C_Queue, this.P_NewQueue)
		context.updateColumnWithParam(context.tt.uExt.C_Ordinal, this.P_NewOrdinal)
	}

	private class _Constructor(
		override val targetTable: Table<T_User2Queue, *>
	) : UpdateQuery.SingleRow.Constructor<U_MoveUserInQueue, T_User2Queue> {
		override fun createUpdateSingleWithReturning(context: UpdateQuery.SingleRow.Constructor.Scope<U_MoveUserInQueue, T_User2Queue>) = U_MoveUserInQueue(context)
	}

	companion object Constructor {
		operator fun invoke(module: Module<M_V0>): UpdateQuery.SingleRow.Constructor<U_MoveUserInQueue, T_User2Queue> = _Constructor(module.uExt.user2queue)
	}
}